/*
Inbox

Inbox API can be used for low level integration and enables direct communication with you contact base.   In most cases you will use our interaction templates for communication, but our api also allows you to send message directly.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package inboxapi

import (
	"encoding/json"
)

// checks if the AgentRequestData type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &AgentRequestData{}

// AgentRequestData struct for AgentRequestData
type AgentRequestData struct {
	Source string `json:"source"`
	TransactionId *string `json:"transaction_id,omitempty"`
}

// NewAgentRequestData instantiates a new AgentRequestData object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewAgentRequestData(source string) *AgentRequestData {
	this := AgentRequestData{}
	this.Source = source
	return &this
}

// NewAgentRequestDataWithDefaults instantiates a new AgentRequestData object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewAgentRequestDataWithDefaults() *AgentRequestData {
	this := AgentRequestData{}
	return &this
}

// GetSource returns the Source field value
func (o *AgentRequestData) GetSource() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Source
}

// GetSourceOk returns a tuple with the Source field value
// and a boolean to check if the value has been set.
func (o *AgentRequestData) GetSourceOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Source, true
}

// SetSource sets field value
func (o *AgentRequestData) SetSource(v string) {
	o.Source = v
}

// GetTransactionId returns the TransactionId field value if set, zero value otherwise.
func (o *AgentRequestData) GetTransactionId() string {
	if o == nil || IsNil(o.TransactionId) {
		var ret string
		return ret
	}
	return *o.TransactionId
}

// GetTransactionIdOk returns a tuple with the TransactionId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *AgentRequestData) GetTransactionIdOk() (*string, bool) {
	if o == nil || IsNil(o.TransactionId) {
		return nil, false
	}
	return o.TransactionId, true
}

// HasTransactionId returns a boolean if a field has been set.
func (o *AgentRequestData) HasTransactionId() bool {
	if o != nil && !IsNil(o.TransactionId) {
		return true
	}

	return false
}

// SetTransactionId gets a reference to the given string and assigns it to the TransactionId field.
func (o *AgentRequestData) SetTransactionId(v string) {
	o.TransactionId = &v
}

func (o AgentRequestData) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o AgentRequestData) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["source"] = o.Source
	if !IsNil(o.TransactionId) {
		toSerialize["transaction_id"] = o.TransactionId
	}
	return toSerialize, nil
}

type NullableAgentRequestData struct {
	value *AgentRequestData
	isSet bool
}

func (v NullableAgentRequestData) Get() *AgentRequestData {
	return v.value
}

func (v *NullableAgentRequestData) Set(val *AgentRequestData) {
	v.value = val
	v.isSet = true
}

func (v NullableAgentRequestData) IsSet() bool {
	return v.isSet
}

func (v *NullableAgentRequestData) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableAgentRequestData(val *AgentRequestData) *NullableAgentRequestData {
	return &NullableAgentRequestData{value: val, isSet: true}
}

func (v NullableAgentRequestData) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableAgentRequestData) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


